function debounce (func, ms, immediate = false) {
  let timeout

  return function () {
    const thisHolder = this
    const args = arguments
    const later = function () {
      timeout = null
      if (!immediate) {
        func.apply(thisHolder, args)
      }
    }
    const callNow = immediate && !timeout
    clearTimeout(timeout)
    timeout = setTimeout(later, ms)
    if (callNow) {
      func.apply(thisHolder, args)
    }
  }
}

module.exports = debounce
